/* ========================================================================== */
/*!
 * 
 */
/* ========================================================================== */
using System;
using System.Reflection;
using System.Collections.Generic;
using System.Threading;
using System.Net;
using System.IO;
using System.Web;

namespace RecTestSched
{
    internal class TwitterClient : IDisposable
    {
        //!
        private const string TWC_URL_UPDATE = "http://twitter.com/statuses/update.xml";
        //!
        private System.Threading.Timer myTimer;
        //!
        private string myUserName;
        //!
        private string myPassword;
        //!
        private string myMessage;

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        public TwitterClient(string _user
                            , string _pass
                            , string _msg
                            )
        {
            try
            {
                myMessage = HttpUtility.UrlEncode(_msg);
                myUserName = _user;
                myPassword = _pass;
                TimerCallback timerCallBack = new System.Threading.TimerCallback(TimerProc);
                myTimer = new System.Threading.Timer(timerCallBack, null, 0, 1 * 1000);
            }
            catch (Exception exp)
            {
                Release();
                General.LogOut(0, "vZX̋NɎs܂I");
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        ~TwitterClient()
        {
            Release();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        public void Dispose()
        {
            Release();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void Release()
        {
            TimerStop();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void TimerStop()
        {
            try
            {
                if (myTimer != null)
                {
                    General.TimerPause(myTimer);
                    myTimer.Dispose();
                    myTimer = null;
                }
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void TimerProc(object param)
        {
            General.TimerPause(myTimer);
            AssemblyName asmName = Assembly.GetExecutingAssembly().GetName();
            try
            {
                HttpWebRequest httpRequest = (HttpWebRequest)HttpWebRequest.Create(TWC_URL_UPDATE);
                httpRequest.Method = "POST";
                httpRequest.Credentials = new NetworkCredential(myUserName, myPassword);
                httpRequest.ContentType = "application/x-www-form-urlencoded";
                httpRequest.UserAgent = "RecTestSched/" + asmName.Version.Major + "." + asmName.Version.Minor;
                httpRequest.Timeout = 20000;
                ServicePointManager.Expect100Continue = false;
                using (StreamWriter httpWrite = new StreamWriter(httpRequest.GetRequestStream()))
                {
                    httpWrite.Write("status={0}", myMessage);
                    httpWrite.Close();
                }
                using (WebResponse httpResponse = httpRequest.GetResponse())
                {
                    using (StreamReader httpReader = new StreamReader(httpResponse.GetResponseStream()))
                    {
                        string strResult = httpReader.ReadToEnd();
                        httpReader.Close();
                    }
                    httpResponse.Close();
                }
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
            this.Dispose();
        }


    }
}