﻿using System;
using System.Collections.Generic;
using System.Text;

namespace RecTestSchediEPG
{
    internal class Channel : IDisposable 
    {
        //!
        static private List<Channel> myChannel;
        //!
        internal string myiEPGStation;
        //!
        internal string myRecStation;
        //!
        internal int myAddStart;
        //!
        internal int myAddLength;

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public List<Channel> List()
        {
            if (myChannel == null)
            {
                myChannel = new List<Channel>();
            }
            return myChannel;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public void DelInstance()
        {
            if (myChannel != null)
            {
                myChannel.Clear();
                myChannel = null;
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public void Update( string _iEPG
                                 , string _station
                                 , int _addStart
                                 , int _addLength
                                 )
        {
            foreach (Channel ch in List())
            {
                if (ch.myiEPGStation == _iEPG)
                {
                    ch.myRecStation = _station;
                    ch.myAddStart = _addStart;
                    ch.myAddLength = _addLength;
                    return;
                }
            }
            try
            {
                new Channel(_iEPG, _station, _addStart, _addLength);
            }
            catch (Exception exp)
            {
                General.OutputString(exp.StackTrace, exp.Message);
            }
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        public Channel( string _iEPG
                      , string _station
                      , int _addStart
                      , int _addLength
                      )
        {
            myiEPGStation = _iEPG;
            myRecStation = _station;
            myAddStart = _addStart;
            myAddLength = _addLength;
            myChannel.Add(this);
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        ~Channel()
        {
            Release();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        public void Dispose()
        {
            Release();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void Release()
        {
        }

    }
}
