﻿using System;
using System.Collections.Generic;
using System.Text;
using System.IO;

namespace RecTestSchediEPG
{
    class iEPGFile : IDisposable 
    {
        //!
        static public iEPGFile myiEPG = null;
        //!
        public string myStation;
        //!
        public string myTitle;
        //!
        public DateTime myDate;
        //!
        public int myLength;

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        static public iEPGFile GetInstance()
        {
            return myiEPG;
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        public iEPGFile(string _path)
        {
            if (System.IO.File.Exists(_path))
            {
                string strYear = "";
                string strMonth = "";
                string strDate = "";
                string strStart = "";
                string strEnd = "";
                using (StreamReader fpReader = new StreamReader(_path, Encoding.GetEncoding("Shift_JIS")))
                {
                    while (fpReader.Peek() > -1)
                    {
                        string tmp = fpReader.ReadLine();
                        if (tmp == "") { break; }

                        string[] field = tmp.Split(':');
                        switch (field[0])
                        {
                            case "version":
                                break;

                            case "station":
                                myStation = field[1].Trim();
                                break;

                            case "year":
                                strYear = field[1].Trim();
                                break;

                            case "month":
                                strMonth = field[1].Trim();
                                break;

                            case "date":
                                strDate = field[1].Trim();
                                break;

                            case "start":
                                strStart = field[1].Trim() + field[2].Trim();
                                break;

                            case "end":
                                strEnd = field[1].Trim() + field[2].Trim();
                                break;

                            case "program-title":
                                myTitle = tmp.Substring(tmp.IndexOf(':') + 1).Trim();
                                break;

                            case "genre":
                                break;

                            case "subgenre":
                                break;
                        }
                    }
                    fpReader.Close();
                }
                if (strYear != ""
                    &&
                    strMonth != ""
                    &&
                    strDate != ""
                    &&
                    strStart != ""
                    &&
                    strEnd != ""
                  )
                {
                    string fmt = strYear + strMonth + strDate + strStart;
                    myDate = DateTime.ParseExact(fmt, "yyyyMMddHHmm", null);
                    fmt = strYear + strMonth + strDate + strEnd;
                    DateTime dateEnd = DateTime.ParseExact(fmt, "yyyyMMddHHmm", null);
                    TimeSpan span = dateEnd - myDate;
                    if (span.TotalSeconds < 1)
                    {
                        myLength = Convert.ToInt32(span.TotalMinutes);
                        myLength += 24 * 60;
                    }
                    else
                    {
                        myLength = Convert.ToInt32(span.TotalMinutes);
                    }
                    if (myiEPG != null)
                    {
                        myiEPG.Dispose();
                    }
                    myiEPG = this;
                    return;
                }
                else
                {
                    throw new Exception("フォーマットが正しくありません");
                }
            }
            throw new Exception("ファイルが見つかりません");
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        ~iEPGFile()
        {
            Release();
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        public void Dispose()
        {
        }

        /* ========================================================================== */
        /*!
         */
        /* ========================================================================== */
        private void Release()
        {
        } 


    }
}
