﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;
using System.Diagnostics;

namespace RecTestSchediEPG
{
    public partial class iEPGForm : Form
    {
        public iEPGForm()
        {
            InitializeComponent();
        }

        private void iEPGForm_Load(object sender, EventArgs e)
        {
            AssemblyName asmName = Assembly.GetExecutingAssembly().GetName();
            this.Text = "iEPG to Scheduler"
                      + "  Ver." + asmName.Version.Major + "." + asmName.Version.Minor + asmName.Version.Build;

            Config.GetInstance().Import();
            RefreshChannel();

            try
            {
                new iEPGFile(Config.GetInstance().OpenPath());
            }
            catch
            {
            }

            buttonRefresh_Click(sender, e);
        }

        private void buttonRefresh_Click(object sender, EventArgs e)
        {
            if (!RequestChannel())
            {
                ShowForm();
            }
        }

        private void buttonOK_Click(object sender, EventArgs e)
        {
            if (CheckiEPGInfo())
            {
                Channel.Update(comboBoxStation.Text
                              , comboBoxRecCh.Text
                              , General.ToInt32(textBoxAddStart.Text)
                              , General.ToInt32(textBoxAddLength.Text)
                              );
                Config.GetInstance().Export();
                SendiEPG();
            }
        }

        private void comboBoxStation_SelectedIndexChanged(object sender, EventArgs e)
        {
            UpdateStationSelect(comboBoxStation.Text);
        }
    }
}